static const char AUTHOR[] = "@(#)$Id: getfntbl.c,v 1.2 1999/09/24 00:04:36 rk Exp $";
#include <stdio.h>
#include "reflex.h"
/*
 *********************************************************************
 *
 *     This software is copyrighted by R.K.Owen,Ph.D. 1995
 *
 * The author, R.K.Owen, of this software is not liable for any
 * problems WHATSOEVER which may result from use  or  abuse  of
 * this software. The author, R.K.Owen, grants unlimited rights
 * to anyone who uses and modifies this  software  for  private
 * non-commercial  use  as  long  as  this copyright and rights
 * notice remains in this software and is made available to all
 * recipients of this software.
 *
 * last known email: rk@owen.sj.ca.us
 *                   libreflex@kooz.sj.ca.us
 *
 *********************************************************************
 */

int GetFieldNameTbls(FILE *In, VarLenBuf *FieldNameIndex,
	VarLenBuf *FieldNameText, VarLenBuf *FieldDirectory, char *ErrMsg) {

	/* skip sort info */
	/* The file position must be at the start of the Field Name block */
	/* the location is given by the FieldDir section descriptor in the */
	/* Reflex Header block */
	if (fseek(In, 12, SEEK_CUR)) {
		(void) PasteMessage("GetFieldNameTbls : fseek error", ErrMsg);
		return -1;
	}
	if (BuildBuffer(In, FieldNameIndex, ErrMsg)) {
		(void) PasteMessage("GetFieldNameTbls : FieldNameIndex error",
			ErrMsg);
		return -1;
	}
	if (BuildBuffer(In, FieldNameText, ErrMsg)) {
		(void) PasteMessage("GetFieldNameTbls : FieldNameText error",
			ErrMsg);
		return -1;
	}
	if (BuildBuffer(In, FieldDirectory, ErrMsg)) {
		(void) PasteMessage("GetFieldNameTbls : FieldDirectory error",
			ErrMsg);
		return -1;
	}
	return 0;
}
